# 5.1.0

Release date: `2021-03-12`

## Core

- [NXDRIVE-2476](https://jira.nuxeo.com/browse/NXDRIVE-2476): Add usage metrics in HTTP headers
- [NXDRIVE-2479](https://jira.nuxeo.com/browse/NXDRIVE-2479): Fix transfers stability when using S3 direct upload
- [NXDRIVE-2523](https://jira.nuxeo.com/browse/NXDRIVE-2523): Prevent crashes because of too many opened file descriptors
- [NXDRIVE-2531](https://jira.nuxeo.com/browse/NXDRIVE-2531): Finish refactoring of `Processor._execute()` for Direct Transfer actions
- [NXDRIVE-2530](https://jira.nuxeo.com/browse/NXDRIVE-2530): Add logs for the deletion behavior state
- [NXDRIVE-2538](https://jira.nuxeo.com/browse/NXDRIVE-2538): Take into account the deletion behavior when handling deleted files at startup
- [NXDRIVE-2539](https://jira.nuxeo.com/browse/NXDRIVE-2539): Fix endless synchronization on permission error when setting the remote ID on a file
- [NXDRIVE-2550](https://jira.nuxeo.com/browse/NXDRIVE-2550): Prevent Sentry flooding
- [NXDRIVE-2552](https://jira.nuxeo.com/browse/NXDRIVE-2552): Pass a custom callback for token renewal on S3
- [NXDRIVE-2553](https://jira.nuxeo.com/browse/NXDRIVE-2553): Adapt the code following recent Python client changes
- [NXDRIVE-2557](https://jira.nuxeo.com/browse/NXDRIVE-2557): Add a Google Analytics metric for the machine type

### Direct Transfer

- [NXDRIVE-2382](https://jira.nuxeo.com/browse/NXDRIVE-2382): Add CSV export capability for sessions
- [NXDRIVE-2537](https://jira.nuxeo.com/browse/NXDRIVE-2537): Enable the Direct Transfer feature by default
- [NXDRIVE-2559](https://jira.nuxeo.com/browse/NXDRIVE-2559): CSV filename should be elided when too long
- [NXDRIVE-2569](https://jira.nuxeo.com/browse/NXDRIVE-2569): Fix error notification when the upload is paused

## GUI

- [NXDRIVE-2504](https://jira.nuxeo.com/browse/NXDRIVE-2504): Focus on the filters warning message box
- [NXDRIVE-2551](https://jira.nuxeo.com/browse/NXDRIVE-2551): Reword the auto-update option on the Settings screen
- [NXDRIVE-2562](https://jira.nuxeo.com/browse/NXDRIVE-2562): Always bring the account window after being redirected from the browser
- [NXDRIVE-2568](https://jira.nuxeo.com/browse/NXDRIVE-2568): Add the Python client version in the About tab
- [NXDRIVE-2570](https://jira.nuxeo.com/browse/NXDRIVE-2570): Fix window focus that sometimes is lost

## Packaging / Build

- [NXDRIVE-2529](https://jira.nuxeo.com/browse/NXDRIVE-2529): Upgrade from Python 3.9.1 to 3.9.2
- [NXDRIVE-2554](https://jira.nuxeo.com/browse/NXDRIVE-2554): Change the default Administrator password

## Tests

- [NXDRIVE-2543](https://jira.nuxeo.com/browse/NXDRIVE-2543): Fix `test_file_action_with_values()` to finish the action
- [NXDRIVE-2549](https://jira.nuxeo.com/browse/NXDRIVE-2549): Fix test number display

## Minor Changes

- Upgraded `nuxeo` from 4.0.0 to 5.0.0
- Upgraded `pypac` from 0.14.0 to 0.15.0
- Upgraded `pyinstaller-hooks-contrib` from 2020.11 to 2021.1
- Upgraded `sentry-sdk` from 0.20.3 to 1.0.0
- Upgraded `zipp` from 3.4.0 to 3.4.1

## Technical Changes

- Added `force` argument to `Application.refresh_completed_sessions_items()`
- Added `CompletedSessionModel.CSV_PATH`
- Added `EngineDAO.get_session_items()`
- Added `EngineDAO.save_session_item()`
- Changed `EngineDAO.sessionUpdated`. Now takes a `bool` argument.
- Added `Manager.generate_csv()`
- Removed `Manager.arch`
- Added `Options.custom_metrics`
- Added `Options.custom_metrics_poll_interval`
- Added `Options.exec_profile`
- Added `Options.session_uid`
- Added `QMLDriveAPI.generate_csv()`
- Removed `QMLDriveAPI.open_report()`. Use `.open_in_explorer()` instead.
- Added `Remote.metrics`
- Added `headers` keyword argument to `Remote.unlock()`
- Added `headers` keyword argument to `Remote.upload_folder()`
- Removed `Tracker.current_locale`. Use utils.py::`get_current_locale()` instead.
- Removed `Tracker.user_agent`. Use metrics/utils.py::`user_agent()` instead.
- Added `Upload.is_dirty`
- Added `Upload.token_refresh()`
- Removed \_\_main\_\_.py::`before_send()`. Use tracing.py::`before_send()` instead.
- Removed \_\_main\_\_.py::`setup_sentry()`. Use tracing.py::`setup_sentry()` instead.
- Added constants.py::`SYNC_ROOT`
- Removed constants.py::`USER_AGENT`. Use metrics/utils.py::`user_agent()` instead.
- Added metrics/
- Added session_csv.py
- Added tracing.py
- Added utils.py::`get_current_locale()`
- Removed utils.py::`DEVICE_DESCRIPTIONS`
- Removed utils.py::`ga_user_agent()`. Use metrics/utils.py::`user_agent()` instead.
- Removed utils.py::`get_arch()`
- Removed utils.py::`get_current_os()`. Use metrics/utils.py::`current_os()` instead.
- Removed utils.py::`get_current_os_full()`
- Removed utils.py::`get_device()`
